"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Colors = void 0;
var react_1 = __importDefault(require("react"));
var ui_1 = require("@/components/ui");
var colors_1 = __importDefault(require("@/components/ui/colors"));
var title_1 = require("./title");
var Colors = function () {
    return (<>
      <title_1.Title text="Colors"/>
      {Object.keys(colors_1.default).map(function (name) { return (<Color name={name} key={name}/>); })}
    </>);
};
exports.Colors = Colors;
var Color = function (_a) {
    var name = _a.name;
    if (typeof colors_1.default[name] === 'string')
        return null;
    return (<ui_1.View className="pt-2">
      <ui_1.Text className="font-medium">{name.toUpperCase()}</ui_1.Text>
      <ui_1.View className="flex-row flex-wrap content-between justify-around ">
        {Object.entries(colors_1.default[name]).map(function (_a) {
            var key = _a[0], value = _a[1];
            return (<ColorCard key={"".concat(colors_1.default[name], "-").concat(key)} value={key} color={value}/>);
        })}
      </ui_1.View>
    </ui_1.View>);
};
var ColorCard = function (_a) {
    var color = _a.color, value = _a.value;
    return (<ui_1.View className="flex-1">
      <ui_1.View className="h-14 w-full rounded-sm" style={{ backgroundColor: color }}/>
      <ui_1.Text className="text-sm">{value}</ui_1.Text>
    </ui_1.View>);
};
//# sourceMappingURL=colors.js.map