"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable max-lines-per-function */
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var test_utils_1 = require("@/lib/test-utils");
var button_1 = require("./button");
afterEach(test_utils_1.cleanup);
describe('Button component ', function () {
    it('should render correctly ', function () {
        (0, test_utils_1.render)(<button_1.Button testID="button"/>);
        expect(test_utils_1.screen.getByTestId('button')).toBeOnTheScreen();
    });
    it('should render correctly if we add explicit child ', function () {
        (0, test_utils_1.render)(<button_1.Button testID="button">
        <react_native_1.Text> Custom child </react_native_1.Text>
      </button_1.Button>);
        expect(test_utils_1.screen.getByText('Custom child')).toBeOnTheScreen();
    });
    it('should render the label correctly', function () {
        (0, test_utils_1.render)(<button_1.Button testID="button" label="Submit"/>);
        expect(test_utils_1.screen.getByTestId('button')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByText('Submit')).toBeOnTheScreen();
    });
    it('should render the loading indicator correctly', function () {
        (0, test_utils_1.render)(<button_1.Button testID="button" loading={true}/>);
        expect(test_utils_1.screen.getByTestId('button')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('button-activity-indicator')).toBeOnTheScreen();
    });
    it('should call onClick handler when clicked', function () { return __awaiter(void 0, void 0, void 0, function () {
        var onClick, user;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    onClick = jest.fn();
                    user = (0, test_utils_1.setup)(<button_1.Button testID="button" label="Click the button" onPress={onClick}/>).user;
                    expect(test_utils_1.screen.getByTestId('button')).toBeOnTheScreen();
                    return [4 /*yield*/, user.press(test_utils_1.screen.getByTestId('button'))];
                case 1:
                    _a.sent();
                    expect(onClick).toHaveBeenCalledTimes(1);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be disabled when loading', function () { return __awaiter(void 0, void 0, void 0, function () {
        var onClick, user;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    onClick = jest.fn();
                    user = (0, test_utils_1.setup)(<button_1.Button testID="button" loading={true} label="Click the button" onPress={onClick}/>).user;
                    expect(test_utils_1.screen.getByTestId('button')).toBeOnTheScreen();
                    expect(test_utils_1.screen.getByTestId('button-activity-indicator')).toBeOnTheScreen();
                    expect(test_utils_1.screen.getByTestId('button')).toBeDisabled();
                    return [4 /*yield*/, user.press(test_utils_1.screen.getByTestId('button'))];
                case 1:
                    _a.sent();
                    expect(onClick).toHaveBeenCalledTimes(0);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be disabled when disabled prop is true', function () {
        (0, test_utils_1.render)(<button_1.Button testID="button" disabled={true}/>);
        expect(test_utils_1.screen.getByTestId('button')).toBeDisabled();
    });
    it("shouldn't call onClick when disabled", function () { return __awaiter(void 0, void 0, void 0, function () {
        var onClick, user;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    onClick = jest.fn();
                    user = (0, test_utils_1.setup)(<button_1.Button testID="button" label="Click the button" disabled={true} onPress={onClick} variant="secondary"/>).user;
                    expect(test_utils_1.screen.getByTestId('button')).toBeOnTheScreen();
                    return [4 /*yield*/, user.press(test_utils_1.screen.getByTestId('button'))];
                case 1:
                    _a.sent();
                    expect(test_utils_1.screen.getByTestId('button')).toBeDisabled();
                    expect(onClick).toHaveBeenCalledTimes(0);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should apply correct styles based on size prop', function () {
        (0, test_utils_1.render)(<button_1.Button testID="button" size="lg"/>);
        var button = test_utils_1.screen.getByTestId('button');
        // TODO: should be fixed to use haveStyle instead of comparing the class name
        var expectedStyle = 'font-inter font-semibold text-white dark:text-black text-xl';
        var receivedStyle = button.props.children[0].props.children.props.className;
        expect(receivedStyle).toContain(expectedStyle);
    });
    it('should apply correct styles for label when variant is secondary', function () {
        (0, test_utils_1.render)(<button_1.Button testID="button" variant="secondary" label="Submit"/>);
        var button = test_utils_1.screen.getByTestId('button');
        var expectedStyle = 'font-inter font-semibold text-secondary-600 text-base';
        var receivedStyle = button.props.children[0].props.children.props.className;
        expect(receivedStyle).toContain(expectedStyle);
    });
    it('should apply correct styles for label when is disabled', function () {
        (0, test_utils_1.render)(<button_1.Button testID="button" label="Submit" disabled/>);
        var button = test_utils_1.screen.getByTestId('button');
        var expectedStyle = 'font-inter font-semibold text-base text-neutral-600 dark:text-neutral-600';
        var receivedStyle = button.props.children[0].props.children.props.className;
        expect(receivedStyle).toContain(expectedStyle);
    });
});
//# sourceMappingURL=button.test.js.map