"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable max-lines-per-function */
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var test_utils_1 = require("@/lib/test-utils");
var input_1 = require("./input");
afterEach(test_utils_1.cleanup);
describe('Input component ', function () {
    it('renders correctly ', function () {
        (0, test_utils_1.render)(<input_1.Input testID="input"/>);
        expect(test_utils_1.screen.getByTestId('input')).toBeOnTheScreen();
    });
    it('should use the right direction for rtl layout', function () {
        react_native_1.I18nManager.isRTL = true;
        (0, test_utils_1.render)(<input_1.Input testID="input"/>);
        expect(test_utils_1.screen.getByTestId('input')).toHaveStyle({
            writingDirection: 'rtl',
        });
    });
    it('should use the right direction for ltr layout', function () {
        react_native_1.I18nManager.isRTL = false;
        (0, test_utils_1.render)(<input_1.Input testID="input"/>);
        expect(test_utils_1.screen.getByTestId('input')).toHaveStyle({
            writingDirection: 'ltr',
        });
    });
    it('should render the placeholder correctly ', function () {
        (0, test_utils_1.render)(<input_1.Input testID="input" placeholder="Enter your username"/>);
        expect(test_utils_1.screen.getByTestId('input')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByPlaceholderText('Enter your username')).toBeOnTheScreen();
    });
    it('should render the label correctly ', function () {
        (0, test_utils_1.render)(<input_1.Input testID="input" label="Username"/>);
        expect(test_utils_1.screen.getByTestId('input')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('input-label')).toHaveTextContent('Username');
    });
    it('should render the error message correctly ', function () {
        (0, test_utils_1.render)(<input_1.Input testID="input" error="This is an error message"/>);
        expect(test_utils_1.screen.getByTestId('input')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('input-error')).toHaveTextContent('This is an error message');
    });
    it('should render the label, error message & placeholder correctly ', function () {
        (0, test_utils_1.render)(<input_1.Input testID="input" label="Username" placeholder="Enter your username" error="This is an error message"/>);
        expect(test_utils_1.screen.getByTestId('input')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('input-label')).toHaveTextContent('Username');
        expect(test_utils_1.screen.getByTestId('input-error')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('input-error')).toHaveTextContent('This is an error message');
        expect(test_utils_1.screen.getByPlaceholderText('Enter your username')).toBeOnTheScreen();
    });
    it('should trigger onFocus event correctly ', function () { return __awaiter(void 0, void 0, void 0, function () {
        var onFocus, user, input;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    onFocus = jest.fn();
                    user = (0, test_utils_1.setup)(<input_1.Input testID="input" onFocus={onFocus}/>).user;
                    input = test_utils_1.screen.getByTestId('input');
                    return [4 /*yield*/, user.type(input, 'test text')];
                case 1:
                    _a.sent();
                    expect(onFocus).toHaveBeenCalledTimes(1);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should trigger onBlur event correctly ', function () { return __awaiter(void 0, void 0, void 0, function () {
        var onBlur, user, input;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    onBlur = jest.fn();
                    user = (0, test_utils_1.setup)(<input_1.Input testID="input" onBlur={onBlur}/>).user;
                    input = test_utils_1.screen.getByTestId('input');
                    return [4 /*yield*/, user.type(input, 'test text')];
                case 1:
                    _a.sent();
                    expect(onBlur).toHaveBeenCalledTimes(1);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should trigger onChangeText event correctly', function () { return __awaiter(void 0, void 0, void 0, function () {
        var onChangeText, user, input;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    onChangeText = jest.fn();
                    user = (0, test_utils_1.setup)(<input_1.Input testID="input" onChangeText={onChangeText}/>).user;
                    input = test_utils_1.screen.getByTestId('input');
                    return [4 /*yield*/, user.type(input, '123456789')];
                case 1:
                    _a.sent();
                    expect(onChangeText).toHaveBeenCalledTimes(9); // every character is a change event
                    expect(onChangeText).toHaveBeenCalledWith('123456789');
                    return [2 /*return*/];
            }
        });
    }); });
    it('should be disabled when disabled prop is true', function () {
        (0, test_utils_1.render)(<input_1.Input testID="input" disabled={true}/>);
        var input = test_utils_1.screen.getByTestId('input');
        expect(input.props.disabled).toBe(true);
    });
});
//# sourceMappingURL=input.test.js.map