"use strict";
/* eslint-disable max-lines-per-function */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var test_utils_1 = require("@/lib/test-utils");
var select_1 = require("./select");
afterEach(test_utils_1.cleanup);
describe('Select component ', function () {
    var options = [
        { value: 'chocolate', label: 'Chocolate' },
        { value: 'strawberry', label: 'Strawberry' },
        { value: 'vanilla', label: 'Vanilla' },
    ];
    it('should render correctly ', function () {
        var onSelect = jest.fn();
        (0, test_utils_1.render)(<select_1.Select label="Select options" options={options} onSelect={onSelect} testID="select"/>);
        expect(test_utils_1.screen.getByTestId('select-trigger')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('select-label')).toBeOnTheScreen();
    });
    it('should render the label correctly ', function () {
        var onSelect = jest.fn();
        (0, test_utils_1.render)(<select_1.Select label="Select" options={options} onSelect={onSelect} testID="select"/>);
        expect(test_utils_1.screen.getByTestId('select-trigger')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('select-label')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('select-label')).toHaveTextContent('Select');
    });
    it('should render the error correctly ', function () {
        var onSelect = jest.fn();
        (0, test_utils_1.render)(<select_1.Select label="Select" options={options} onSelect={onSelect} testID="select" error="Please select an option"/>);
        expect(test_utils_1.screen.getByTestId('select-trigger')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('select-error')).toBeOnTheScreen();
        expect(test_utils_1.screen.getByTestId('select-error')).toHaveTextContent('Please select an option');
    });
    it('should open options modal on press', function () { return __awaiter(void 0, void 0, void 0, function () {
        var user, selectTrigger;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    user = (0, test_utils_1.setup)(<select_1.Select label="Select" options={options} testID="select" placeholder="Select an option"/>).user;
                    selectTrigger = test_utils_1.screen.getByTestId('select-trigger');
                    return [4 /*yield*/, user.press(selectTrigger)];
                case 1:
                    _a.sent();
                    expect(test_utils_1.screen.getByTestId('select-item-chocolate')).toBeOnTheScreen();
                    expect(test_utils_1.screen.getByTestId('select-item-strawberry')).toBeOnTheScreen();
                    expect(test_utils_1.screen.getByTestId('select-item-vanilla')).toBeOnTheScreen();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should call onSelect on selecting an option', function () { return __awaiter(void 0, void 0, void 0, function () {
        var onSelect, user, selectTrigger, optionModal, optionItem1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    onSelect = jest.fn();
                    user = (0, test_utils_1.setup)(<select_1.Select options={options} onSelect={onSelect} testID="select"/>).user;
                    selectTrigger = test_utils_1.screen.getByTestId('select-trigger');
                    return [4 /*yield*/, user.press(selectTrigger)];
                case 1:
                    _a.sent();
                    optionModal = test_utils_1.screen.getByTestId('select-modal');
                    return [4 /*yield*/, user.press(optionModal)];
                case 2:
                    _a.sent();
                    optionItem1 = test_utils_1.screen.getByTestId('select-item-chocolate');
                    return [4 /*yield*/, user.press(optionItem1)];
                case 3:
                    _a.sent();
                    expect(onSelect).toHaveBeenCalledWith(options[0].value);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=select.test.js.map